#include <Siv3D.hpp>

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;

/// <summary>Œ蒷obt@ɕ𖄂ߍ</summary>
/// <param name="buf">mۍς݃obt@</param>
/// <param name="num">obt@oCg</param>
/// <param name="s"></param>
/// <param name="nullTerminate">NULL~ߗL</param>
/// <returns>true: Afalse: s</returns>
bool SetPmdText(char* buf,int num, String s,bool nullTerminate = true) {
	::memset(buf, 0, num);

	std::string ms = s.narrow();
	int len = ::strlen(ms.c_str());
	int size = Min(len, num - (nullTerminate == true));
	::memcpy(buf,ms.c_str(),size);
	return (size >= len);
}

/// <summary>.pmdt@Co͂</summary>
/// <param name="w">oCiC^</param>
/// <param name="m">bVf[^</param>
/// <param name="mat">ގ</param>
/// <param name="fullImage">eNX`̃tpX</param>
/// <returns>true: Afalse: eNX`rŌĂ</returns>
bool SavePmd(BinaryWriter& w,MeshData& m, Material& mat,
	String& fullImage) {
	bool texNameWhole = false;

	char buf[256];

	// wb_
	SetPmdText(buf, 3, L"Pmd",false);
	w.write(buf, 3);
	w.write<float>(1.0f);
	SetPmdText(buf, 20, L"f");
	w.write(buf,20);
	SetPmdText(buf, 256, L"Rg");
	w.write(buf,256);
	// _
	w.write<int>(m.vertices.size());
	for (const auto& v : m.vertices) {
		w.write<float>(v.position.x);
		w.write<float>(v.position.y);
		w.write<float>(v.position.z);
		w.write<float>(v.normal.x);
		w.write<float>(v.normal.y);
		w.write<float>(v.normal.z);
		w.write<float>(v.texcoord.x);
		w.write<float>(v.texcoord.y);

		w.write<short>(0); // {[1
		w.write<short>(0); // {[2
		w.write<u8>(100); // {[1ւ̉e%
		w.write<u8>(0); // GbW 0ʏ
	}

	// _CfbNX
	w.write<int>(m.indices.size());
	for (const auto& idx : m.indices) {
		w.write<u16>(idx);
	}
	// ގ
	int num = 1;
	w.write<int>(num);
	{
		ColorF c = mat.diffuse;
		w.write<float>(c.r);
		w.write<float>(c.g);
		w.write<float>(c.b);
		w.write<float>(c.a);

		w.write<float>(mat.shininess);

		c = mat.specular;
		w.write<float>(c.r);
		w.write<float>(c.g);
		w.write<float>(c.b);

		c = mat.ambient;
		w.write<float>(c.r);
		w.write<float>(c.g);
		w.write<float>(c.b);

		w.write<u8>(255); // gD[CfbNX
		w.write<u8>(0); // GbWtO
		w.write<int>(m.indices.size());
// NULL~ߏԂɂ(MMM̂߂)
		texNameWhole = SetPmdText(buf, 20, FileSystem::FileName(fullImage),true);
		w.write(buf, 20);
	}
	// {[
	num = 1;
	w.write<short>(num);
	for (int i = 0; i < num; ++i) {
		SetPmdText(buf, 20, L"Z^[");
		w.write(buf, 20);
		w.write<short>(-1);
		w.write<short>(0);
		w.write<u8>(1); // 
		w.write<short>(0);

		Vec3 pos(0,0,0);
		w.write<float>(pos.x);
		w.write<float>(pos.y);
		w.write<float>(pos.z);
	}
	// IKXg
	w.write<short>(0);
	// \Xg
	int morphNum = 0;
	w.write<short>(morphNum);
	// \gp\Xg
	w.write<u8>(morphNum);
	// {[gpgXg
	int frameNum = (0 + 249) / 250;
	w.write<u8>(frameNum);
	// {[gp\Xg
	num = 0;
	w.write<int>(num);

	// p
	int isEn = 0;
	w.write<u8>(isEn);

	// gD[
	for (int i = 0; i < 10; ++i) {
		String name = Format(L"toon", i+1, L".bmp");
		SetPmdText(buf, 100, name);
		w.write(buf, 100);
	}
	// 
	num = 0;
	w.write<int>(num);
	// WCg
	num = 0;
	w.write<int>(num);

	return texNameWhole;
}

/// <summary>o͂Ă݂</summary>
/// <param name="m">o͂3DbV</param>
/// <param name="fullImage">摜t@CtpX</param>
void MakeFile(MeshData& m,String& fullImage) {
	auto saveName = Dialog::GetSave({ { L"ft@C(*.pmd)", L"*.pmd" } },
		L"Oĕۑ",FileSystem::ParentPath(fullImage));
	if (saveName == false) {
		return;
	}

	Material mat;
	mat.diffuse = Color{255, 255, 255, 255 };
	mat.shininess = 5;
	mat.specular = Color{ 128, 128, 128, 255 };
	mat.ambient = Color{ 64, 64, 64, 255 };

	BinaryWriter writer(saveName.value());
	bool result = SavePmd(writer,m,mat,fullImage);
	if (result) {
		MessageBox::Show(L"ۑ܂");
	}
	else {
		MessageBox::Show(L"ۑ܂eNX`Ă܂");
	}
}

/// <summary>C</summary>
void Main() {
	Window::SetTitle(L"|[J[");

	GUI gui(GUIStyle::Default);
	gui.setTitle(L"j[");
	gui.add(L"op1", GUIButton::Create(L"摜I"));
	gui.addln(L"ot1", GUIButton::Create(L"fo"));
	gui.button(L"ot1").enabled = false;
	gui.setPos(Window::Width() - gui.getRect().w - 4, 4);

	Polygon simple;
	DynamicTexture dtex;
	MeshData meshData;
	DynamicMesh dmesh;
	String fullImage;

	Camera cam;
	cam.pos = { 0, 0, -40 };
	Graphics3D::SetCamera(cam);

	while (System::Update()) {
		Graphics3D::FreeCamera();

		Cone(20, 0, 0, 1, 2).draw(Palette::Red);
		Cone(-20, 0, 0, 1, 2).draw(Palette::Red);
		Cone(0, 0, -50, 1, 2).draw();

		if (gui.button(L"op1").pushed) {
			Optional<String> imgFile = Dialog::GetOpenBasicImage();
			if (imgFile) {
				fullImage = imgFile.value();
				std::string fileName = FileSystem::FileName(fullImage).narrow();
				int len = strlen(fileName.c_str());
				if (len > 19) {
					MessageBox::Show(L"t@Ĉ.pmdo͎ɌĂ܂܂");
				}

				Image img(fullImage);
				const s3d::Polygon bound = Imaging::FindContour(img,true);
				simple = bound.simplified();

				int num = simple.num_triangles;

				dtex = DynamicTexture(img);

				meshData.vertices.clear();
				meshData.vertices.reserve(num * 3);

				meshData.indices.clear();
				meshData.indices.reserve(num * 3);
				int index = 0;

				double dw = dtex.width;
				double dh = dtex.height;
				double rate = Max(dw, dh);
				double size = 20.0;
				double k = size / rate;
				Vec3 t(dtex.width / 2, dtex.height / 2, 0);

				auto tris = simple.triangles();
				for (const auto& tri : tris) {
					Vec3 n(0, 0, -1);
					for (int j = 0; j < 3; ++j) {
						MeshVertex vtx;
						vtx.position = { (tri.p[j].x - t.x) * k, - (tri.p[j].y - t.y) * k, 0 };
						vtx.texcoord = { tri.p[j].x / dw, tri.p[j].y / dh };
						vtx.normal = n;
						meshData.vertices.push_back(vtx);
					}

					meshData.indices.push_back(index);
					meshData.indices.push_back(index + 1);
					meshData.indices.push_back(index + 2);
					index += 3;
				}

				dmesh = DynamicMesh(meshData);

				gui.button(L"ot1").enabled = true;
			}
		}

		if (gui.button(L"ot1").pushed) {
			MakeFile(meshData,fullImage);
		}

		if (dmesh) {
			dmesh.draw(dtex);
		}
	}
}
